<?php

require_once 'base/FpafaixatabelaEntityBase.php';


/**
 * Enter description here ...
 *
 * @package Entity
 * @author  alessandrobartels
 */
class FpafaixatabelaEntity extends FpaFaixatabelaEntityBase
{
    private static  $_faixas = array();


    /**
     * Adiciona itens em uma lista.
     *
     * @param TkDateTime $data_competencia Data de competencia.
     *
     * @return void
     */
    public static function inicializaLista(TkDateTime $data_competencia){
        $tmp = Fpafaixatabela::retornaFaixas($data_competencia);
        foreach ($tmp as $tmp_faixa) {
            self::$_faixas[$tmp_faixa->getNrtabelafolha()][] = $tmp_faixa;
            /* self::addItem($tmp_faixa,$tmp_faixa->nrtipoincide); */
        }

    }


    /**
     * Enter description here ...
     *
     * @param integer    $vr_base          Valor base.
     * @param integer    $nr_tabela        Numero de referencia a tabela de impostos/encargos.
     * @param TkDateTime $data_competencia Data de competencia.
     * @param float      &$percentual      Percentual aplicado. Passado como referencia para ser usado pelo chamador.
     *
     * @return float
     */
    public static function retornaValorProcessado($vr_base, $nr_tabela, TkDateTime $data_competencia, &$percentual ){
        if (empty(self::$_faixas) === true) {
            self::inicializaLista($data_competencia);
        }

        $tabela = self::$_faixas[$nr_tabela];
        $iteracao = 0;
        foreach ($tabela as $item) {
            $iteracao++;
            $i = ($vr_base <= $item->getVrlimitsupfaixa());
            if ($vr_base <= $item->getVrlimitsupfaixa()) {
                /* alessandrobartels 30/08/2011 - Implementacao do percentual passado como referencia */
                $percentual = (float)$item->getVrpecalculoresu();

                $sub_total = ($vr_base * $percentual) / 100;

                // A comparacao de uma variavel (float) com '0' deve ser feita com casa decimal (0.0).
                if (((float)$item->getVrmaxresultcalc() !== 0.0)
                    && ((float)$item->getVrmaxresultcalc() < $sub_total)
                ) {
                    $sub_total = $item->getVrmaxresultcalc();
                }

                $sub_total += $item->getVraplicaresult();

                return $sub_total;
            }
        }

        return 0;
    }

    /**
     * BORBA 07/11/2014 Criado provisóriamente até que se decida melhor sobre o processo de calculo de INSS fora da tabela de INSS definida pela CLT
     *
     * @param integer    $vr_base          Valor base.
     * @param integer    $nr_tabela        Numero de referencia a tabela de impostos/encargos.
     * @param TkDateTime $data_competencia Data de competencia.
     * @param float      &$percentual      Percentual aplicado. Passado como referencia para ser usado pelo chamador.
     *
     * @return float
     */
    public static function retornaValorUltimaFaixa($vr_base, $nr_tabela, TkDateTime $data_competencia, &$percentual ){
        if (empty(self::$_faixas) === true) {
            self::inicializaLista($data_competencia);
        }
        $tabela = self::$_faixas[$nr_tabela];
        $iteracao = 0;
        foreach ($tabela as $item) {
            $iteracao++;
            //Verifica unica faixa que tem teto, que é sempre a última
            if ((float)$item->getVrmaxresultcalc() !== 0.0){
                $percentual = (float)$item->getVrpecalculoresu();
                $sub_total = ($vr_base * $percentual) / 100;

                if((float)$item->getVrmaxresultcalc() < $sub_total){
                    $sub_total = $item->getVrmaxresultcalc();
                }
                $sub_total += $item->getVraplicaresult();
                //tk_warning('B '.$vr_base.'  -  P '.$percentual.'  - ST '.$sub_total);
                return $sub_total;
            }
        }

        return 0;
    }

}

