/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PRODRALIMENT                                             */
/* Tabela : PRODRALIMENT                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 27/06/2007 - FELIPE HENRIQUE                                               */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
             o.name = 'DTULTATU_PRODRALIMENT'and
             type = 'TR'                     and
             u.uid = o.uid                   and
             u.name = USER)
   DROP TRIGGER DTULTATU_PRODRALIMENT
GO

CREATE TRIGGER DTULTATU_PRODRALIMENT
ON PRODRALIMENT
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                              (SELECT 'PRODRALIMENT', CDFILIAL, 'CDFILIAL=' + CDFILIAL + ';' +
                                                                'CDCLIENTE=' + CDCLIENTE + ';' +
                                                                'CDCONSUMIDOR=' + CDCONSUMIDOR + ';' +
                                                                'CDFAMILISALD=' + CDFAMILISALD  + ';' +
                                                                'CDPRODUTO=' + CDPRODUTO + ';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED);
   END
   ELSE BEGIN
      UPDATE PRODRALIMENT
      SET DTULTATUPRRALIM = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(PRODRALIMENT.CDFILIAL,0)     = ISNULL(INSERTED.CDFILIAL,0))AND
            (ISNULL(PRODRALIMENT.CDCLIENTE,0)    = ISNULL(INSERTED.CDCLIENTE,0))AND
            (ISNULL(PRODRALIMENT.CDCONSUMIDOR,0) = ISNULL(INSERTED.CDCONSUMIDOR,0))AND
            (ISNULL(PRODRALIMENT.CDFAMILISALD,0) = ISNULL(INSERTED.CDFAMILISALD,0))AND
            (ISNULL(PRODRALIMENT.CDPRODUTO,0)    = ISNULL(INSERTED.CDPRODUTO,0));
   END;
END;
GO

UPDATE PRODRALIMENT SET DTULTATUPRRALIM = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUPRRALIM IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUPRRALIM' and
            type = 'D')
   ALTER TABLE PRODRALIMENT DROP CONSTRAINT DEFAULT_DTULTATUPRRALIM
GO

ALTER TABLE PRODRALIMENT ADD CONSTRAINT DEFAULT_DTULTATUPRRALIM
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUPRRALIM
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_PRODRALIMENT','4.11.194';
GO

